/*
 * 产品品牌
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class KqProductBrandController : BaseController
    {
        public KqProductBrandController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 产品品牌列表

        /// <summary>
        /// 根据条件查询产品品牌列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(KqProductBrand data, string right, string ProductId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ProductId = ProductId;


            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询产品品牌列表

        /// <summary>
        /// 产品品牌列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(KqProductBrand data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ProductId", "1");

            Fields.Add("Name", "2"); //品牌名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("KqProductBrand", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加产品品牌

        /// <summary>
        /// 增加或修改产品品牌信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string ProductId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ProductId = ProductId;


            return View();
        }

        #endregion

        #region 增加产品品牌

        /// <summary>
        /// 增加或修改产品品牌信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(KqProductBrand data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ProductId", data.ProductId);

            Fields.Add("Name", data.Name); //品牌名称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("KqProductBrand", Fields, 0);
            AddSysLog(data.Id.ToString(), "KqProductBrand", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改产品品牌

        /// <summary>
        /// 增加或修改产品品牌信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ProductId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ProductId = ProductId;


            KqProductBrand editData = db.KqProductBrand.FirstOrDefault(m => m.Id == Id) ?? new KqProductBrand();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改产品品牌

        /// <summary>
        /// 增加或修改产品品牌信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(KqProductBrand data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ProductId", data.ProductId);

            Fields.Add("Name", data.Name); //品牌名称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("KqProductBrand", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"KqProductBrand","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除产品品牌信息

        /// <summary>
        /// 删除产品品牌信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"KqProductBrand","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("KqProductBrand", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"KqProductBrand","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("KqProductBrand", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"KqProductBrand","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("KqProductBrand", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("KqProductBrand", Sort, Id);
            
            AddSysLog(Id.ToString(), "KqProductBrand", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.KqProductBrand.Add(new KqProductBrand()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "KqProductBrand", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(KqProductBrand data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //品牌名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("KqProductBrand", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "KqProductBrand", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
